// Uebung2 Betriebssysteme 2
// Matthias Jauernig, 2006
// Ausgabe-Programm

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/msg.h>
#include <sys/shm.h>

#define MAXL 500
#define TIMEOUT 100

#define WLOCKEDSHM 'w'
#define RLOCKEDSHM 'r'
#define QUITSHM 'q'

// Summary: Ausgabefunktion
// Speichert Daten im shared memory Bereich ab
// param adr: Adresse des Pufferbereichs
// param anz: Anzahl der Daten in Byte
// param data: gelesene Daten
// return: Anzahl gelesener Datenbytes
int input(char *adr, int anz, char* data)
{
	//printf("Jetzt in Input...\n");
	//printf("adr[0] == %c\n", adr[0]);
	printf(".");
	while(adr[0]==RLOCKEDSHM) usleep(TIMEOUT);// printf("%c", adr[0]); // auf anliegende Daten warten
	if(adr[0] != QUITSHM){ // Daten lesen, wenn Eingabeprozess nicht beendet
		strcpy(data, adr+1);
		adr[0]=RLOCKEDSHM; // Eingabeprozess Schreibrecht geben
		//printf("Jetzt aus Input...\n");
		return strlen(data)+1;
	}
	else
		return 0; // letzte Daten nicht doppelt lesen
}

void printUse(char* progname){
	printf("Benutzung: %s textfile\n", progname);
}

int main(int argc, char** argv){
	char* data = (char*)malloc(MAXL*sizeof(char));
	FILE* fp = NULL;
	int shmid, shmflag, shmsize;
	key_t shmkey;
	char* shmadr;
	
	// Name von zu schreibender Datei holen
	if(argc != 2){
		printUse(argv[0]);
		return 1;
	}
	
	fp=fopen(argv[1],"w");
	if (fp==NULL)
	{
		printf("Konnte Datei nicht zum Schreiben oeffnen!\n");
		return 2;	
	}

	// Shared Memory anlegen bzw. verfuegbar machen
	shmsize = MAXL;
	shmkey = ftok("ueb2_eingabe.c", 1); // Key fuer IPC anhand Filenamens erzeugen
	shmflag = IPC_CREAT | 0644;
	if((shmid=shmget(shmkey, shmsize, shmflag)) < 0){ // Shared Mem erzeugen bzw. oeffnen
		perror("Konnte Shared Memory nicht anlegen / oeffnen.");
		fclose(fp);
		return 3;
	}
	shmadr = shmat(shmid, 0, 0); // Prozess an Shared Memory anhaengen
	
	while(shmadr[0] != WLOCKEDSHM) usleep(TIMEOUT); // warten bis Eingabeprozess Daten geschrieben hat

	// solange Daten lesen bis Eingabeprozess beendet wurde
	while(shmadr[0] != QUITSHM){
		int bytes = input(shmadr, shmsize, data);
		if(bytes > 0)
			fputs(data, fp);
	}

	printf("\n");
	fclose(fp);
	shmdt(shmadr); // Zuordnung des shared mem zum Prozess beenden
	shmctl(shmid, IPC_RMID, 0); // Segment aus System entfernen

	return 0;
}
